Constrainte loi de Snell (refraction de la lumière) Sketcher

From FreeCAD Documentation
Jump to: navigation, search
This page is a translated version of the page Sketcher ConstrainSnellsLaw and the translation is 100% complete.

Other languages:
English • ‎español • ‎français • ‎italiano • ‎русский

Constraint SnellsLaw.svg Contrainte de réfraction

Emplacement du menu
Sketch → Sketcher Contraintes → Contrainte de réfraction (Loi de Snell)
Ateliers
Sketcher
Raccourci par défaut
Aucun
Introduit dans la version
0.15
Voir aussi
Aucun


Description

Contraint deux lignes à suivre la loi de la réfraction de la lumière qui pénètre à travers une interface, où deux matériaux de différents indices de réfraction se rencontrent. Voir [ http://fr.wikipedia.org/wiki/Loi_de_Snell_Descartes Loi de Snell] sur Wikipedia pour plus d'info.

Snell's law


Utilisation

La séquence de clics est indiqué par des flèches jaunes avec des numéros. n1, n2 sont labelisées sur cette photo uniquement pour montrer où sont les indices de réfraction.
  • Vous aurez besoin de deux lignes qui vont suivre un faisceau de lumière, et une courbe pour agir comme une interface. Les lignes doivent être sur des côtés différents de l'interface.
  • Sélectionnez l'extrémité d'une ligne, un point d'extrémité d'une autre ligne, et le bord de l'interface. L'interface peut être une ligne, un cercle / arc, ellipse / arc d'ellipse. Notez l'ordre dans lequel vous avez sélectionné les paramètres.
  • Appelez la contrainte. Une boîte de dialogue apparaît pour demander un rapport d'indices de réfraction n2 / n1. n2 correspond au milieu où la ligne du deuxième critère sélectionné réside, n1 est pour la première ligne.
  • Les critères d'évaluation seront mis en coïncidence (si nécessaire), contraint à l'interface (si nécessaire), et la loi de Snell deviendront contraint.

Notez que plusieurs contraintes Sketcher Aide pour contraindre seront ajoutées intelligemment (point sur objet, coïncident). Ils peuvent être supprimés s'ils causent une redondance ou ajoutés manuellement s'ils n'ont pas été ajoutés automatiquement. Pour la contrainte de la loi de Snell, les extrémités des lignes doivent coïncider et reposer sur l'interface, sinon le comportement n'est pas défini.

En utilisant l'outil Polyligne d'esquisse Sketcher Sketcher CreatePolyline.png, il est possible d'accélérer le tracé des rayons de lumière. Dans ce cas, il est possible de sélectionner deux extrémités coïncidentes par sélection de boîte.

Remarques

  • La contrainte actuelle de la loi de Snell applique la plaine équation de la loi n1 * sin (theta1) = n2 * sin (theta2). Il a besoin que les extrémités des lignes soient confondues et sur l'interface par d'autres contraintes. Les contraintes auxiliaires nécessaires sont ajoutées automatiquement en fonction des coordonnées actuelles des éléments.
  • La routine de Python n'ajoute pas les contraintes d'aide. Celles-ci doivent être ajoutées manuellement par le script (voir l'exemple dans la section Script)
  • Ces contraintes auxiliaires peuvent être supprimées temporairement et les points terminaux traînés dehors, ce qui peut être utile au cas où on veut construire un rayon réfléchi ou des rayons biréfringent.
  • Contrairement à la réalité, les indices de réfraction sont associés à des rayons de lumière, mais non pas selon les côtés de la frontière. C'est utile pour émuler la biréfringence, construire des chemins de longueurs d'onde différentes en raison de la réfraction, et construire facilement l'angle de début de réflexion interne totale.
  • Les deux rayons peuvent être sur le même côté de l'interface, répondant à l'équation de contrainte. Cela n'a aucun sens physique, à moins que le rapport n2 / n1 est de 1,0, auquel cas la contrainte émule une réflexion.
  • Arcs de cercle et une ellipse sont également acceptés comme les rayons (non-sens physique).

Script

Les contraintes peuvent être créées à partir de macros et de la console python en utilisant la fonction suivante:

Sketch.addConstraint(Sketcher.Constraint('SnellsLaw',line1,pointpos1,line2,pointpos2,interface,n2byn1))

où:

* Sketch </ tt> est un objet d'esquisse
* <Tt> ligne1 </ tt> et <tt> pointpos1 </ tt> sont deux entiers identifiant l'extrémité de la ligne dans le milieu d'indice de réfraction de n1 . <tt> ligne1 </ tt> est l'index de la ligne dans l'esquisse (la valeur retournée par Sketch.addGeometry), et <tt> pointpos1 </ tt> devrait être de 1 pour point de départ et 2 pour le point de fin.
* <Tt> line2 </ tt> et <tt> pointpos2 </ tt> sont les indices spécifiant le point final de la deuxième ligne (dans un milieu n2 )
* <Tt> n2byn1 </ tt> est un nombre à virgule flottante égal au rapport des indices de réfraction n2 / n1

Exemple:

import Sketcher
import Part
import FreeCAD

StartPoint = 1
EndPoint = 2
MiddlePoint = 3

f = App.activeDocument().addObject("Sketcher::SketchObject","Sketch")

# add geometry to the sketch
icir = f.addGeometry(Part.Circle(App.Vector(-547.612366,227.479736,0),App.Vector(0,0,1),68.161979))
iline1 = f.addGeometry(Part.LineSegment(App.Vector(-667.331726,244.127090,0),App.Vector(-604.284241,269.275238,0)))
iline2 = f.addGeometry(Part.LineSegment(App.Vector(-604.284241,269.275238,0),App.Vector(-490.940491,256.878265,0)))
# add constraints
# helper constraints:
f.addConstraint(Sketcher.Constraint('Coincident',iline1,EndPoint,iline2,StartPoint)) 
f.addConstraint(Sketcher.Constraint('PointOnObject',iline1,EndPoint,icir)) 
# the Snell's law:
f.addConstraint(Sketcher.Constraint('SnellsLaw',iline1,EndPoint,iline2,StartPoint,icir,1.47))

App.ActiveDocument.recompute()

Version

La contrainte a été introduit en FreeCAD v0.15.4387